# -*- python -*-
# $RCSfile: pixelinfoGUI.py,v $
# $Revision: 1.6 $
# $Author: langer $
# $Date: 2004/06/08 21:36:02 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from SWIG.common import switchboard
from SWIG.engine import material
from common import debug
from common.IO.GUI import pixelinfoGUI
from gtk import *

class MaterialPlugIn(pixelinfoGUI.PixelInfoPlugIn):
    ordering = 3
    nrows = 1
    def __init__(self, toolbox, table, row):
        debug.mainthreadTest()
        pixelinfoGUI.PixelInfoPlugIn.__init__(self, toolbox)

        label=GtkLabel('Material=')
        label.set_alignment(1.0, 0.5)
        table.attach(label, 0,1, row,row+1, xpadding=5, xoptions=FILL)
        self.materialtext = GtkEntry()
        self.materialtext.set_editable(0)
        table.attach(self.materialtext, 1,2, row,row+1,
                     xpadding=5, xoptions=EXPAND|FILL)
        self.sbcb = switchboard.requestCallback(
            'materials changed in microstructure', self.matchanged)

    def close(self):
        switchboard.removeCallback(self.sbcb)
        pixelinfoGUI.PixelInfoPlugIn.close(self)

    def update(self, where):
        debug.mainthreadTest()
        microstructure = self.toolbox.findMicrostructure()
        if microstructure and where is not None:
            mat = material.getMaterialFromPoint(microstructure, where)
            if mat:
                self.materialtext.set_text(mat.name())
                return
        self.materialtext.set_text('<No material>')

    def nonsense(self):
        debug.mainthreadTest()
        self.materialtext.set_text('???')

    def matchanged(self, ms):
        if ms is self.toolbox.findMicrostructure():
            self.update(self.toolbox.currentPixel())

pixelinfoGUI.registerPlugInClass(MaterialPlugIn)
