# This file was created automatically by SWIG.
import conjugatec
from SWIG.engine.fieldindex import FieldIndexPtr
from SWIG.engine.field import FieldPtr
from SWIG.engine.equation import EquationPtr
class ConjugatePairPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def get_field(self, *_args, **_kwargs):
        val = apply(conjugatec.ConjugatePair_get_field,(self,) + _args, _kwargs)
        if val: val = FieldPtr(val) 
        return val
    def get_field_component(self, *_args, **_kwargs):
        val = apply(conjugatec.ConjugatePair_get_field_component,(self,) + _args, _kwargs)
        if val: val = FieldIndexPtr(val) 
        return val
    def get_equation(self, *_args, **_kwargs):
        val = apply(conjugatec.ConjugatePair_get_equation,(self,) + _args, _kwargs)
        return val
    def get_equation_component(self, *_args, **_kwargs):
        val = apply(conjugatec.ConjugatePair_get_equation_component,(self,) + _args, _kwargs)
        if val: val = FieldIndexPtr(val) 
        return val
    def get_name(self, *_args, **_kwargs):
        val = apply(conjugatec.ConjugatePair_get_name,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C ConjugatePair instance at %s>" % (self.this,)
class ConjugatePair(ConjugatePairPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(conjugatec.new_ConjugatePair,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: conjugate_.py,v $
# $Revision: 1.3 $
# $Author: redwing $
# $Date: 2004/12/07 15:25:51 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

class ListOfConjugatePairs:
    def __init__(self):
        self.pairs = []
        self.number_of_pairs = 0
    def add(self, conjpair):
        if conjpair not in self.pairs:
            self.pairs.append(conjpair)
            self.number_of_pairs += 1
    def remove(self, key):
        del self.pairs[key]
        self.conjpairslist -= 1
    def get(self, key):
        return self.pairs[key]
    def check_sanity(self):
        for i in range(self.pairs):
            cpair1 = self.pairs[i]
            for j in range(i + 1, self.pairs):
                cpair2 = self.pairs[j]
                if cpair1 != cpair2:
                    if cpair1.get_equation() == cpair2.get_equation() \
                    and cpair1.get_equation_component() == cpair2.get_equation_component():
                        ## if they share the same equation
                        ## and they share the same equation components
                        if cpair1.get_field() != cpair2.get_field() \
                        or cpair1.get_field_component() != cpair2.get_field_component():
                            ## but they are conjugate to different field components
                            return 0 ## relationship overdefined, and symmetry will not be reached
        return 1 ## all relationships unique
    def old_find_local_mapping(self, femesh):
        ## femesh is a real FEMesh
        mapping = {}
        for conjugatepair in self.pairs:
            field = conjugatepair.get_field()
            fieldcomp = conjugatepair.get_field_component()
            equation = conjugatepair.get_equation()
            equationcomp = conjugatepair.get_equation_component()
            ## if field is defined assign the defined_index
            ## to the mapping list, otherwise assign -1
            if femesh.is_defined(field) and femesh.is_active_equation(equation):
                mapping[(equation, equationcomp.integer())] = femesh.defined_index(field) + fieldcomp.integer()
        return mapping

    def find_local_mapping(self, femesh):
        ## femesh is a real FEMesh
        local_row = []
        local_col = []
        
        for conjugatepair in self.pairs:
            field = conjugatepair.get_field()
            fieldcomp = conjugatepair.get_field_component()
            equation = conjugatepair.get_equation()
            equationcomp = conjugatepair.get_equation_component()
            ## if field is defined assign the defined_index
            ## to the mapping list, otherwise assign -1
            if femesh.is_defined(field) and femesh.is_active_equation(equation):
                eqcomp = femesh.active_equation_index(equation) + equationcomp.integer()
                fcomp = femesh.defined_index(field) + fieldcomp.integer()
                local_row.append(eqcomp)
                local_col.append(fcomp)
        return local_row, local_col
    

_ConjugatePairOld__init__ = ConjugatePair.__init__

def _ConjugatePair__init__(self, name, equation, eqncomp, field, fieldcomp):
    _ConjugatePairOld__init__(self, name, equation, eqncomp, field, fieldcomp)
    listofconjugatepairs.add(self)

ConjugatePair.__init__ = _ConjugatePair__init__

listofconjugatepairs = ListOfConjugatePairs()
