# This file was created automatically by SWIG.
import equationc
from SWIG.engine.fieldindex import IteratorPPtr
from SWIG.engine.fieldindex import IndexPPtr
class EquationPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def name(self, *_args, **_kwargs):
        val = apply(equationc.Equation_name,(self,) + _args, _kwargs)
        return val
    def objectid(self, *_args, **_kwargs):
        val = apply(equationc.Equation_objectid,(self,) + _args, _kwargs)
        return val
    def dim(self, *_args, **_kwargs):
        val = apply(equationc.Equation_dim,(self,) + _args, _kwargs)
        return val
    def ndof(self, *_args, **_kwargs):
        val = apply(equationc.Equation_ndof,(self,) + _args, _kwargs)
        return val
    def fluxname(self, *_args, **_kwargs):
        val = apply(equationc.Equation_fluxname,(self,) + _args, _kwargs)
        return val
    def nodaleqn(self, *_args, **_kwargs):
        val = apply(equationc.Equation_nodaleqn,(self,) + _args, _kwargs)
        if val: val = NodalEquationPtr(val) 
        return val
    def iterator(self, *_args, **_kwargs):
        val = apply(equationc.Equation_iterator,(self,) + _args, _kwargs)
        if val: val = IteratorPPtr(val) ; val.thisown = 1
        return val
    def componenttype(self, *_args, **_kwargs):
        val = apply(equationc.Equation_componenttype,(self,) + _args, _kwargs)
        if val: val = IndexPPtr(val) ; val.thisown = 1
        return val
    def getIndex(self, *_args, **_kwargs):
        val = apply(equationc.Equation_getIndex,(self,) + _args, _kwargs)
        if val: val = IndexPPtr(val) ; val.thisown = 1
        return val
    def __repr__(self):
        return "<C Equation instance at %s>" % (self.this,)
class Equation(EquationPtr):
    def __init__(self,this):
        self.this = this




class DivergenceEquationPtr(EquationPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C DivergenceEquation instance at %s>" % (self.this,)
class DivergenceEquation(DivergenceEquationPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(equationc.new_DivergenceEquation,_args,_kwargs)
        self.thisown = 1




class PlaneFluxEquationPtr(EquationPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C PlaneFluxEquation instance at %s>" % (self.this,)
class PlaneFluxEquation(PlaneFluxEquationPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(equationc.new_PlaneFluxEquation,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------

countEquations = equationc.countEquations

def getEquationByIndex(*_args, **_kwargs):
    val = apply(equationc.getEquationByIndex,_args,_kwargs)
    return val



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: equation_.py,v $
# $Revision: 1.11 $
# $Author: langer $
# $Date: 2003/12/02 19:42:29 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

from common import debug
from common import utils
from engine import component
import types

def _Equation___hash_(self):
    return self.objectid()

EquationPtr.__hash__ = _Equation___hash_

def _Equation___cmp__(self, other):
    if not isinstance(other, EquationPtr): return -1
    if self.objectid() < other.objectid(): return -1
    if self.objectid() > other.objectid(): return 1
    return 0

EquationPtr.__cmp__ = _Equation___cmp__

##EquationPtr.__repr__ = lambda self: "getEquation('%s')" % self.name()
##DivergenceEquationPtr.__repr__ = lambda self: "getEquation('%s')" % self.name()
##PlaneFluxEquationPtr.__repr__ = lambda self: "getEquation('%s')" % self.name()

EquationPtr.__repr__ = EquationPtr.name
DivergenceEquationPtr.__repr__ = DivergenceEquationPtr.name
PlaneFluxEquationPtr.__repr__ = PlaneFluxEquationPtr.name

from SWIG.engine.nodalequation import NodalEquationPtr

# AllEquations acts like a list of Equations
class _AllEquations:
    def __getitem__(self, indx):
        if type(indx) == types.IntType:
            if indx >= countEquations() or indx < 0:
                raise IndexError("Bad equation index: " + str(indx))
            return getEquationByIndex(indx)
        elif type(indx) == types.StringType:
            for i in range(countEquations()):
                eqn = getEquationByIndex(i)
                if eqn.name() == indx:
                    return eqn
            raise IndexError("Bad equation name: " + indx)
    def __len__(self):
        return countEquations()

allEquations = _AllEquations()

def getEquation(name):
    return allEquations[name]

utils.OOFdefine('getEquation', getEquation)

def _Equation___getitem__(self, comp):
    # deFortranify
    if type(comp) is types.TupleType:
        c = [x-1 for x in comp]
    else:
        c = [comp-1]
    return component.Component(self, c)

EquationPtr.__getitem__ = _Equation___getitem__
