# This file was created automatically by SWIG.
import isoc
from SWIG.engine.property.elasticity.elasticity import ElasticityPtr
from SWIG.engine.property.elasticity.cijkl import CijklPtr
class IsoElasticityPropPtr(ElasticityPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def cijkl_pointer(self, *_args, **_kwargs):
        val = apply(isoc.IsoElasticityProp_cijkl_pointer,(self,) + _args, _kwargs)
        if val: val = CijklPtr(val) 
        return val
    def __repr__(self):
        return "<C IsoElasticityProp instance at %s>" % (self.this,)
class IsoElasticityProp(IsoElasticityPropPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(isoc.new_IsoElasticityProp,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: iso_.py,v $
# $Revision: 1.24 $
# $Author: langer $
# $Date: 2004/12/15 21:53:52 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from common.IO import parameter
from engine import problem
from engine import propertyregistration
from engine.IO import isocijkl

PropertyRegistration = propertyregistration.PropertyRegistration

# Property class registration code
PropertyRegistration(
    "Elasticity:Isotropic", IsoElasticityProp,
    "SWIG.engine.property.elasticity.iso.iso", 10,
    [isocijkl.IsotropicRank4TensorParameter('cijkl',
                          isocijkl.IsotropicRank4TensorCij(c11=1.0, c12=0.5),
                                            tip=parameter.emptyTipString)],
    fields=[problem.Displacement],
    fluxes=[problem.Stress],
    outputs=["Energy"],
    propertyType="Elasticity",
    discussion='<para>Isotropic linear elasticity.</para>')


# The property's repr refers to the property not by the name of the
# actual class, but by the (leaf of the) registration entry, which
# is how it will be instanced, in general.  The reason for this is
# that it's necessary for the property registration to know about
# the instantiation, so that it can update the PropertyMenu tree,
# and in GUI mode, its corresponding GtkCTree.
def _IsoElasticityProp___repr__(self):
    return "Isotropic(name='%s',cijkl=%s)" % \
           (self.name(), `self.cijkl_param()`)

IsoElasticityPropPtr.__repr__ = _IsoElasticityProp___repr__
  
# Special wrapper function which extracts the property's internal
# cijkl, and presents it in parameter form.
def _IsoElasticityProp_cijkl_param(self):
    cijkl = self.cijkl_pointer()
    return isocijkl.IsotropicRank4TensorCij(c11=cijkl[0,0],c12=cijkl[0,1])

IsoElasticityPropPtr.cijkl_param = _IsoElasticityProp_cijkl_param
