# -*- python -*-
# $RCSfile: skelstiffness_.py,v $
# $Revision: 1.11 $
# $Author: haan $
# $Date: 2004/11/10 15:39:15 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

from engine import propertyregistration
PropertyRegistration = propertyregistration.PropertyRegistration

from common.IO import parameter
FloatParameter = parameter.FloatParameter

from engine.IO import isocijkl 
from engine import problem
import types
from SWIG.common import devel

if devel.devel():
    Skeleton = PropertyRegistration(
        'Elasticity:SkeletonStiffness', SkeletonStiffness,
        "SWIG.engine.property.elasticity.skelstiffness.skelstiffness", 100,
        [isocijkl.IsotropicRank4TensorParameter('cijkl',
                           isocijkl.IsotropicRank4TensorLame(lmbda=8.0, mu=4),
                                                tip=parameter.emptyTipString)],
        fields=[problem.Displacement],
        fluxes=[problem.Stress],
        outputs=["Energy"],
        propertyType="Elasticity",
        nonlinear=1)
    

# Repr refers to registration name, not actual class name.
def _SkeletonStiffness___repr__(self):
    return "SkeletonStiffness(name='%s', cjikl=%s )" % \
           (self.name(), `self.cijkl_param()`)

SkeletonStiffnessPtr.__repr__ = _SkeletonStiffness___repr__

# Ought to be possible to use the instance's conversion machine?
# Or some other more general interface.
def _SkeletonStiffness_cijkl_param(self):
    cijkl = self.cijkl_pointer()
    c11 = cijkl[0,0]
    c12 = cijkl[0,1]
    return isocijkl.IsotropicRank4TensorLame(lmbda=c12, mu=(c11-c12)/2.0)

SkeletonStiffnessPtr.cijkl_param = _SkeletonStiffness_cijkl_param
