# This file was created automatically by SWIG.
import thermoc
from SWIG.engine.properties import PropertyPtr
from SWIG.engine.property.elasticity.cijkl import CijklPtr
from SWIG.engine.property.elasticity.elasticity import ElasticityPtr
class ThermoElasticityPropPtr(ElasticityPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def cijkl_pointer(self, *_args, **_kwargs):
        val = apply(thermoc.ThermoElasticityProp_cijkl_pointer,(self,) + _args, _kwargs)
        if val: val = CijklPtr(val) 
        return val
    def t0(self, *_args, **_kwargs):
        val = apply(thermoc.ThermoElasticityProp_t0,(self,) + _args, _kwargs)
        return val
    def dmudt(self, *_args, **_kwargs):
        val = apply(thermoc.ThermoElasticityProp_dmudt,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C ThermoElasticityProp instance at %s>" % (self.this,)
class ThermoElasticityProp(ThermoElasticityPropPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(thermoc.new_ThermoElasticityProp,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: thermo_.py,v $
# $Revision: 1.23 $
# $Author: haan $
# $Date: 2004/11/10 15:39:15 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

from engine import propertyregistration
PropertyRegistration = propertyregistration.PropertyRegistration

from common.IO import parameter
FloatParameter = parameter.FloatParameter

from engine.IO import isocijkl 
from engine import problem
import types
from SWIG.common import devel

if devel.devel():
    PropertyRegistration(
        'Elasticity:ThermoElasticity', ThermoElasticityProp,
        "SWIG.engine.property.elasticity.thermo.thermo",100,
        [isocijkl.IsotropicRank4TensorParameter('cijkl',
                        isocijkl.IsotropicRank4TensorLame(lmbda=1.0, mu=0.5),
                                                tip=parameter.emptyTipString),
         FloatParameter('t0', 0.0, tip=parameter.emptyTipString),
         FloatParameter('alpha', 0.0, tip=parameter.emptyTipString)],
        fields=[problem.Temperature, problem.Displacement],
        fluxes=[problem.Stress],
        outputs=["Energy"],
        propertyType="Elasticity")
    

# Repr refers to registration name, not actual class name.
def _ThermoElasticity___repr__(self):
    return "ThermoElasticity(name='%s', cjikl=%s, t0=%s, alpha=%s)" % \
           (self.name(), `self.cijkl_param()`,
            `self.t0()`, `self.dmudt()`)

ThermoElasticityPropPtr.__repr__ = _ThermoElasticity___repr__

# Ought to be possible to use the instance's conversion machine?
# Or some other more general interface.
def _ThermoElasticity_cijkl_param(self):
    cijkl = self.cijkl_pointer()
    c11 = cijkl[0,0]
    c12 = cijkl[0,1]
    return isocijkl.IsotropicRank4TensorLame(lmbda=c12, mu=(c11-c12)/2.0)

ThermoElasticityPropPtr.cijkl_param = _ThermoElasticity_cijkl_param
