# This file was created automatically by SWIG.
import symmmatrixc
from SWIG.engine.outputval import OutputValPtr
from SWIG.engine.outputval import OutputValuePtr
class SymmMatrixPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,symmmatrixc=symmmatrixc):
        if self.thisown == 1 :
            symmmatrixc.delete_SymmMatrix(self)
    def size(self, *_args, **_kwargs):
        val = apply(symmmatrixc.SymmMatrix_size,(self,) + _args, _kwargs)
        return val
    def get(self, *_args, **_kwargs):
        val = apply(symmmatrixc.SymmMatrix_get,(self,) + _args, _kwargs)
        return val
    def set(self, *_args, **_kwargs):
        val = apply(symmmatrixc.SymmMatrix_set,(self,) + _args, _kwargs)
        return val
    def __imul__(self, *_args, **_kwargs):
        val = apply(symmmatrixc.SymmMatrix___imul__,(self,) + _args, _kwargs)
        if val: val = SymmMatrixPtr(val) ; val.thisown = 1
        return val
    def __repr__(self):
        return "<C SymmMatrix instance at %s>" % (self.this,)
class SymmMatrix(SymmMatrixPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(symmmatrixc.new_SymmMatrix,_args,_kwargs)
        self.thisown = 1




class SymmMatrix3Ptr(OutputValPtr,SymmMatrixPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,symmmatrixc=symmmatrixc):
        if self.thisown == 1 :
            symmmatrixc.delete_SymmMatrix3(self)
    def trace(self, *_args, **_kwargs):
        val = apply(symmmatrixc.SymmMatrix3_trace,(self,) + _args, _kwargs)
        return val
    def determinant(self, *_args, **_kwargs):
        val = apply(symmmatrixc.SymmMatrix3_determinant,(self,) + _args, _kwargs)
        return val
    def secondInvariant(self, *_args, **_kwargs):
        val = apply(symmmatrixc.SymmMatrix3_secondInvariant,(self,) + _args, _kwargs)
        return val
    def maxEigenvalue(self, *_args, **_kwargs):
        val = apply(symmmatrixc.SymmMatrix3_maxEigenvalue,(self,) + _args, _kwargs)
        return val
    def midEigenvalue(self, *_args, **_kwargs):
        val = apply(symmmatrixc.SymmMatrix3_midEigenvalue,(self,) + _args, _kwargs)
        return val
    def minEigenvalue(self, *_args, **_kwargs):
        val = apply(symmmatrixc.SymmMatrix3_minEigenvalue,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C SymmMatrix3 instance at %s>" % (self.this,)
class SymmMatrix3(SymmMatrix3Ptr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(symmmatrixc.new_SymmMatrix3,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------

def newSymTensorOutputValue(*_args, **_kwargs):
    val = apply(symmmatrixc.newSymTensorOutputValue,_args,_kwargs)
    if val: val = OutputValuePtr(val); val.thisown = 1
    return val



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: symmmatrix_.py,v $
# $Revision: 1.23 $
# $Author: langer $
# $Date: 2004/11/04 15:43:56 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

#
# __setitem__/__getitem__ overrides allow this to work like a
# dictionary.  See also cijkl_.py in the elasticity property files.
#

from SWIG.engine import fieldindex
from common import debug
from common import enum
from common import utils
from common import registeredclass
from common.IO import parameter
from common.IO import output
import string
import struct
import types

def _SymmMatrix___setitem__(self,idx,val):
    size = self.size()
    if len(idx)==2 and 0<=idx[0]<size and 0<=idx[1]<size:
        self.set(idx[0],idx[1],val)
    else:
        raise KeyError("Index out of bounds in SymmMatrix")

SymmMatrixPtr.__setitem__ = _SymmMatrix___setitem__

def _SymmMatrix___getitem__(self,idx):
    size = self.size()
    if len(idx)==2 and 0<=idx[0]<size and 0<=idx[1]<size:
        return self.get(idx[0],idx[1])
    else:
        raise KeyError("Index out of bounds in SymmMatrix")

SymmMatrixPtr.__getitem__ = _SymmMatrix___getitem__

# Mathematica-compatible repr, for debugging.
def _SymmMatrix___repr__(self):
    rowlist = []
    for i in range(self.size()):
        collist = []
        for j in range(self.size()):
            collist.append("%f" % self.get(i,j))
        rowlist.append("{ " + string.join(collist,", ") + " }")
    return "SymmMatrix { " + string.join(rowlist,", ") + " }"

SymmMatrixPtr.__repr__ = _SymmMatrix___repr__

################################################
################################################

# The 3x3 Symmetric Matrix gets special treatment

# Redefine the init so that it accepts keyword arguments (swigged
# functions don't allow keywords).  Have unspecified entries default
# to zero.

_oldSymmMatrix3___init__ = SymmMatrix3.__init__
def _SymmMatrix3___init__(self, xx=0.0, yy=0.0, zz=0.0,
                          yz=0.0, xz=0.0, xy=0.0):
    _oldSymmMatrix3___init__(self, xx, yy, zz, yz, xz, xy)
SymmMatrix3.__init__ = _SymmMatrix3___init__
    
voigtIndices = ((0,0), (1,1), (2,2), (1,2), (0,2), (0,1))
voigtNames = ('xx', 'yy', 'zz', 'yz', 'xz', 'xy')


class VoigtComponent(enum.EnumClass(*voigtNames)): pass

def _SymmMatrix3_voigtValues(self):
    return [self.get(*voigtIndices[i]) for i in range(6)]

SymmMatrix3.voigtValues = _SymmMatrix3_voigtValues

def _SymmMatrix3___repr__(self):
    args = ["%s=%f" % nv for nv in zip(voigtNames, self.voigtValues())]
    return "SymmMatrix3(%s)" % string.join(args, ',')

SymmMatrix3.__repr__ = _SymmMatrix3___repr__

def _SymmMatrix3_component(self, component): # used in Output, below
    # component is a VoigtComponent Enum object
    return self.get(*voigtIndices[component.index()])
SymmMatrix3Ptr.component = _SymmMatrix3_component

utils.OOFdefine('SymmMatrix3', SymmMatrix3)

############

class SymmMatrix3Invariant(registeredclass.RegisteredClass):
    registry = []
    # SymmMatrix3Invariant subclasses must have a __call__ method
    # which takes a SymmMatrix3 and returns a Float.

class STrace(SymmMatrix3Invariant):
    def __call__(self, matrix):
        return matrix.trace()

registeredclass.Registration('Trace', SymmMatrix3Invariant, STrace,
                             ordering=0)

class SSecondInvariant(SymmMatrix3Invariant):
    def __call__(self, matrix):
        return matrix.secondInvariant()

registeredclass.Registration('Second Invariant', SymmMatrix3Invariant,
                             SSecondInvariant, ordering=1)

class SDeterminant(SymmMatrix3Invariant):
    def __call__(self, matrix):
        return matrix.determinant()

registeredclass.Registration('Determinant', SymmMatrix3Invariant,
                             SDeterminant, ordering=2)

############

class SymmMatrix3Parameter(parameter.ParameterBase):
    def checker(self, x):
        if x is not None and not isinstance(x, SymmMatrix3Ptr):
            parameter.raiseTypeError(type(x), SymmMatrix3)
    structfmt =">6d"
    structsize = struct.calcsize(structfmt)
    def binaryRepr(self, datafile, value):
        return struct.pack(SymmMatrix3Parameter.structfmt, *value.voigtValues())
    def binaryRead(self, parser):
        b = parser.getBytes(SymmMatrix3Parameter.structsize)
        vv = struct.unpack(SymmMatrix3Parameter.structfmt, b)
        return SymmMatrix3(*vv)
    def valueDesc(self):
        return "A <link linkend='Object:SymmMatrix3'><classname>SymmMatrix3</classname></link> object."
    # TODO: add api dump for SymmMatrix3
    

## Triclinic is esentially SymmMatrix3, but with a different __repr__.
class TriclinicRank2Tensor(SymmMatrix3):
    def __repr__(self):
        args = ["%s=%f" % nv for nv in zip(voigtNames, self.voigtValues())]
        return "TriclinicRank2Tensor(%s)" % string.join(args, ',')

utils.OOFdefine('TriclinicRank2Tensor', TriclinicRank2Tensor)

class TriclinicRank2TensorParameter(SymmMatrix3Parameter):
    def checker(self, x):
        if x is not None and not isinstance(x, TriclinicRank2Tensor):
            parameter.raiseTypeError(type(x), TriclinicRank2Tensor)
    structfmt =">6d"
    structsize = struct.calcsize(structfmt)
    def binaryRead(self, parser):
        b = parser.getBytes(SymmMatrix3Parameter.structsize)
        vv = struct.unpack(SymmMatrix3Parameter.structfmt, b)
        return TriclinicRank2Tensor(*vv)
    def valueDesc(self):
        return "A <link linkend='Object:TriclinicRank2Tensor'><classname>TriclinicRank2Tensor</classname></link> object."
    # TODO: add api dump for TriclinicRank2Tensor

## For Monoclinic symmetric rank two tensor properties
class MonoclinicRank2Tensor(SymmMatrix3):
    def __init__(self, xx=1, yy = 1, zz = 1, xz = 0.5):
        self.xx = xx
        self.yy = yy
        self.zz = zz
        self.xz = xz
        SymmMatrix3.__init__(self, xx=self.xx, yy=self.yy, zz=self.zz, xz = self.xz)
    def __repr__(self):
        return "MonoclinicRank2Tensor(xx=%f, yy=%f, zz=%f, xz=%f)" %(self.xx, self.yy, self.zz, self.xz)

utils.OOFdefine('MonoclinicRank2Tensor', MonoclinicRank2Tensor)

class MonoclinicRank2TensorParameter(parameter.ParameterBase):
    def checker(self, x):
        if x is not None and not isinstance(x, MonoclinicRank2Tensor):
            parameter.raiseTypeError(type(x), MonoclinicRank2Tensor)
    structfmt =">4d"
    structsize = struct.calcsize(structfmt)
    def binaryRepr(self, datafile, value):
        return struct.pack(MonoclinicRank2TensorParameter.structfmt, value.xx, value.yy, value.zz, value.xz)
    def binaryRead(self, parser):
        b = parser.getBytes(MonoclinicRank2TensorParameter.structsize)
        vv = struct.unpack(MonoclinicRank2TensorParameter.structfmt, b)
        return MonoclinicRank2Tensor(*vv)
    def valueDesc(self):
        return "A <link linkend='Object:MonoclinicRank2Tensor'><classname>MonoclinicRank2Tensor</classname></link> object."
    # TODO: add api dump for MonoclinicRank2Tensor

## For Orthorhombic symmetric rank two tensor properties
class OrthorhombicRank2Tensor(SymmMatrix3):
    def __init__(self, xx=1, yy = 1, zz = 1):
        self.xx = xx
        self.yy = yy
        self.zz = zz
        SymmMatrix3.__init__(self, xx=self.xx, yy=self.yy, zz=self.zz)
    def __repr__(self):
        return "OrthorhombicRank2Tensor(xx=%f, yy=%f, zz=%f)" %(self.xx, self.yy, self.zz)

utils.OOFdefine('OrthorhombicRank2Tensor', OrthorhombicRank2Tensor)

class OrthorhombicRank2TensorParameter(parameter.ParameterBase):
    def checker(self, x):
        if x is not None and not isinstance(x, OrthorhombicRank2Tensor):
            parameter.raiseTypeError(type(x), OrthorhombicRank2Tensor)
    structfmt =">3d"
    structsize = struct.calcsize(structfmt)
    def binaryRepr(self, datafile, value):
        return struct.pack(OrthorhombicRank2TensorParameter.structfmt, value.xx, value.yy, value.zz)
    def binaryRead(self, parser):
        b = parser.getBytes(OrthorhombicRank2TensorParameter.structsize)
        vv = struct.unpack(OrthorhombicRank2TensorParameter.structfmt, b)
        return OrthorhombicRank2Tensor(*vv)
    def valueDesc(self):
        return "A <link linkend='Object:OrthorhombicRank2Tensor'><classname>OrthorhombicRank2Tensor</classname></link> object."
    # TODO: add api dump for OrthorhombicRank2Tensor


## For Tetragonal, Trigonal, Hexagonal, symmetric rank two tensor properties
## Tetragonal, Trigonal, and Hexagonal RankTwoTensor classes are just
## wrappers (makeup, really) so that the UI shows a consistent interface.
## All the functionality is stored in IsoDiffusionRankTwoTensor.

## Base class for Tetragonal, Trigonal, and Hexagonal rank two tensors
class IsoDiffusionPlaneRank2Tensor(SymmMatrix3):
    def __init__(self, xx=1, zz=1):
        self.xx = xx
        self.zz = zz
        self.classname = "IsoDiffusionRank2Tensor"
        SymmMatrix3.__init__(self, xx=self.xx, yy=self.xx, zz=self.zz)
    def __repr__(self):
        return self.classname + "(xx=%f, zz=%f)" %(self.xx, self.zz)
    
class TetragonalRank2Tensor(IsoDiffusionPlaneRank2Tensor):
    def __init__(self, xx=1, zz=1):
        IsoDiffusionPlaneRank2Tensor.__init__(self, xx=xx, zz=zz)
        self.classname = "TetragonalRank2Tensor"
        
utils.OOFdefine('TetragonalRank2Tensor', TetragonalRank2Tensor)

class TrigonalRank2Tensor(IsoDiffusionPlaneRank2Tensor):
    def __init__(self, xx=1, zz=1):
        IsoDiffusionPlaneRank2Tensor.__init__(self, xx=xx, zz=zz)
        self.classname = "TrigonalRank2Tensor"

utils.OOFdefine('TrigonalRank2Tensor', TrigonalRank2Tensor)

class HexagonalRank2Tensor(IsoDiffusionPlaneRank2Tensor):
    def __init__(self, xx=1, zz=1):
        IsoDiffusionPlaneRank2Tensor.__init__(self, xx=xx, zz=zz)
        self.classname = "HexagonalRank2Tensor"
        
utils.OOFdefine('HexagonalRank2Tensor', HexagonalRank2Tensor)

class IsoDiffusionPlaneParameter(parameter.ParameterBase):
    ## base class for Tetragonal, Trigonal, and Hexagonal Rank2Tensor objects
    ## should never be directly called. Only subclasses must be called
    structfmt =">dd"
    structsize = struct.calcsize(structfmt)
    def binaryRepr(self, datafile, value):
        return struct.pack(IsoDiffusionPlaneParameter.structfmt, value.xx, value.zz)
    
class TetragonalRank2TensorParameter(IsoDiffusionPlaneParameter):
    def checker(self, x):
        if x is not None and not isinstance(x, TetragonalRank2Tensor):
            parameter.raiseTypeError(type(x), TetragonalRank2Tensor)
    def binaryRead(self, parser):
        b = parser.getBytes(IsoDiffusionPlaneParameter.structsize)
        vv = struct.unpack(IsoDiffusionPlaneParameter.structfmt, b)
        return TetragonalRank2Tensor(*vv)
    def valueDesc(self):
        return "A <link linkend='Object:TetragonalRank2Tensor'><classname>TetragonalRank2Tensor</classname></link> object."
    # TODO: add api dump for TetragonalRank2Tensor

utils.OOFdefine('HexagonalRank2Tensor', HexagonalRank2Tensor)

class TrigonalRank2TensorParameter(IsoDiffusionPlaneParameter):
    def checker(self, x):
        if x is not None and not isinstance(x, TrigonalRank2Tensor):
            parameter.raiseTypeError(type(x), TrigonalRank2Tensor)
    def binaryRead(self, parser):
        b = parser.getBytes(IsoDiffusionPlaneParameter.structsize)
        vv = struct.unpack(IsoDiffusionPlaneParameter.structfmt, b)
        return TrigonalRank2Tensor(*vv)
    def valueDesc(self):
        return "A <link linkend='Object:TrigonalRank2Tensor'><classname>TrigonalRank2Tensor</classname></link> object."
    # TODO: add api dump for TrigonalRank2Tensor
    
class HexagonalRank2TensorParameter(IsoDiffusionPlaneParameter):
    def checker(self, x):
        ## never called. overwritten by subclases
        if x is not None and not isinstance(x, HexagonalRank2Tensor):
            parameter.raiseTypeError(type(x), HexagonalRank2Tensor)
    def binaryRead(self, parser):
        ## never called. overwritten by subclases
        b = parser.getBytes(IsoDiffusionPlaneParameter.structsize)
        vv = struct.unpack(IsoDiffusionPlaneParameter.structfmt, b)
        return HexagonalRank2Tensor(*vv)
    def valueDesc(self):
        return "A <link linkend='Object:HexagonalRank2Tensor'><classname>HexagonalRank2Tensor</classname></link> object."
    # TODO: add api dump for HexagonalRank2Tensor
    
    
## For Cubic rank two tensor properties

class CubicRank2Tensor (SymmMatrix3):
    def __init__(self, xx=1):
        self.xx = xx
        SymmMatrix3.__init__(self, xx=self.xx, yy=self.xx, zz=self.xx)
    def __repr__(self):
        return "CubicRank2Tensor(xx=%f)" %self.xx
    
utils.OOFdefine('CubicRank2Tensor', CubicRank2Tensor)

class CubicRank2TensorParameter(parameter.ParameterBase):
    def checker(self, x):
        if x is not None and not isinstance(x, CubicRank2Tensor):
            parameter.raiseTypeError(type(x), CubicRank2Tensor)
    structfmt =">d"
    ## the format is ">Nd"
    ## > refers to a portable byte ordering
    ## N means the number of parameters that it takes
    ## d means that the parameters are double
    structsize = struct.calcsize(structfmt)
    def binaryRepr(self, datafile, value):
        return struct.pack(CubicRank2TensorParameter.structfmt, value.xx)
    def binaryRead(self, parser):
        b = parser.getBytes(CubicRank2TensorParameter.structsize)
        vv = struct.unpack(CubicRank2TensorParameter.structfmt, b)
        return CubicRank2Tensor(*vv)
    def valueDesc(self):
        return "A <link linkend='Object:CubicRank2Tensor'><classname>CubicRank2Tensor</classname></link> object."
    # TODO: add api dump for CubicRank2Tensor
    
### Outputs for SymmMatrix3s.

##def _SymmMatrixComponent(sm3s, parameters, *args, **kwargs):
##    comp = parameters[0].value          # A VoigtComponent
##    return [sm3.component(comp) for sm3 in sm3s]

##SymmMatrix3ComponentOutput = output.Output(
##    name="SymmMatrix3 component",
##    func=_SymmMatrixComponent,
##    oType=types.FloatType,
##    inputs=output.Input("symmmatrix3", SymmMatrix3),
##    parameters=enum.EnumParameter("component", VoigtComponent, default="xx"))


##def _SymmMatrixInvariant(sm3s, parameters, *args, **kwargs):
##    invariant = parameters[0].value     # A SymmMatrix3Invariant
##    return map(invariant, sm3s)

##SymmMatrix3InvariantOutput = output.Output(
##    name="SymmMatrix3 invariant",
##    func=_SymmMatrixInvariant,
##    oType=types.FloatType,
##    inputs=output.Input("symmmatrix3", SymmMatrix3),
##    parameters=[parameter.RegisteredParameter("invariant", SymmMatrix3Invariant,
##                                              default=STrace())])
